#include <iostream>
#include <vector>

#include "RawSocket.h"

using namespace std;

int main(int argc, char **argv)
{
    static const size_t bufLen = 2000;
    string recvSrc;
    uint16_t recvPort;
    char buf[bufLen];
    /* get a pointer to the right after the mac, ip, and udp headers */
    char *data = (buf + RawSocket::hdrLen());

    if (argc < 2) {
        std::cerr << "interface argument missing" << std::endl;
        return 1;
    }

    /* create the raw socket object specifying the interface to listen on */
    RawSocket raw(argv[1]);

    while (true) {
        /* wait packets to arrive */
        int bytes = raw.recvFrom(buf, bufLen, recvSrc, recvPort);

        /* print packet info */
        std::cout << "packet from; " << recvSrc << std::endl;
        std::cout << "packet len:  " << bytes << std::endl;

        /* check if content is a text line */
        if (data[bytes - 1] != '\n')
            continue;

        /* print contents as characters */
        for (size_t i = 0; i < bytes; ++i)
            std::cout << reinterpret_cast<unsigned char &>(data[i]);
        std::cout << std::endl;
    }

    return 0;
}
